<?php

namespace Drupal\title_html;

use Drupal\node\Entity\Node;

/**
 * Class having static funtions to use in batch process to copy title values to "Title - HTML" field when enabled.
 */
class CopyTItle {

  /**
   * @param $number
   *  Number of times to execute.
   * @param $context
   *  An array of contextual key/value information for rebuild batch process.
   */
  public static function copyTitles($type, $format, &$context) {
    if ($type) {
      if (empty($context['sandbox'])) {
        $context['sandbox']['progress'] = 0;
        $context['sandbox']['max'] = \Drupal::entityQuery('node')->condition('type', $type)->count()->execute();
        // $context['sandbox']['max'] = 1;
      }
      $batch_size = 10;
      $nids = \Drupal::entityQuery('node')
        ->condition('type', $type)
        ->range($context['sandbox']['progress'] , $batch_size)
        ->execute();

      foreach ($nids as $nid) {
        $node = Node::load($nid);
        $title = $node->getTitle();
        $node->title_html->value = $title;
        $node->title_html->format = 'title';
        $node->save();
        $context['sandbox']['progress']++;
      }
      $context['results']['completed'] = $context['sandbox']['progress'];

      if ($context['sandbox']['progress'] != $context['sandbox']['max']) {
        $context['finished'] = $context['sandbox']['progress'] / $context['sandbox']['max'];
      }
    }
  }

  public static function finishedCopying($success, $results, $operations) {
    $message = \Drupal::translation()
        ->formatPlural($results['completed'] , 'Copied title for one node', 'Copied titles for @count nodes.');
    drupal_set_message($message);
  }
  
}